//
//  ViewController.swift
//  SimpleTVOSSample
//
//  Created by David Cortes on 3/14/19.
//  Copyright © 2023 Akamai. All rights reserved.
//

import UIKit
import AVKit
import AmpCore
import AmpIMA
import GoogleInteractiveMediaAds

class ViewController: UIViewController {
    
    var ampPlayer: AmpPlayer!
    var dai:AmpIMAManager!
    var playerController: AVPlayerViewController = AVPlayerViewController()
    
    let fallbackURL = "http://multiplatform-f.akamaihd.net/i/multi/will/bunny/big_buck_bunny_,640x360_400,640x360_700,640x360_1000,950x540_1500,.f4v.csmil/master.m3u8"

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        self.ampPlayer = AmpPlayer(parentViewController: self, playerController: playerController)
        self.dai = AmpIMAManager(ampPlayer: ampPlayer, videoView: self.view)
        self.ampPlayer.registerObserver(self)
        self.ampPlayer.autoplay = true
        self.ampPlayer.setLicense("AwEMywsi0IrCK6ud/6Sqw81JeQbabvju4rsBCStbH12DHZtuEqHF5cMOT7L7oIMID0UvFd2kLg2pIIvgKY1TBPormMR0DUW4+bJTvP8ivxQxYOlHL8irpLZouth5vmXV51gz4j32GewdL2ALbzKdLQDz1KpYXhTVlMZjkKZq50sSlTNnEEH2EeITFvOt8DREqbbzPP77bJhIcp/iFuVZpJiQ38xOBLF6sxDz/ogEo611nQ==")
        self.dai.registerDaiObserver(self)
        self.dai.requestLiveStream(assetkey: "sN_IYUG8STe1ZzhIIE_ksA", fallbackUrl: fallbackURL)
        // Uncomment to test a VOD stream
        // self.dai.requestVodStream(contentSourceID: "2528370", videoID: "tears-of-steel")
    }
}

extension ViewController:PlayerEventObserver {
    func onAmpError(_ ampPlayer: AmpPlayer, error: PlayerError, code: Int, message: String) {
        print("An error has occurred \(error) \(code) \(message)")
    }
}

extension ViewController: IMAStreamManagerDelegate {
    func streamManager(_ streamManager: IMAStreamManager!, didReceive event: IMAAdEvent!) {
        print("reporting dai didReceive event \(event.typeString)")
    }
    
    func streamManager(_ streamManager: IMAStreamManager!, didReceive error: IMAAdError!) {
        print("reporting dai didReceive error \(error.debugDescription)")
    }
}

